<template>
	<div class="accounts" v-if="state === AccountState.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</div>
	<div class="accounts" v-else>
		<h1>{{ title }}</h1>
		<p>
			Accounts used to log in to The Mana World rEvolt.
		</p>
		<div class="accountContainer">
			<GameAccountCard class="box" v-for="(account, key) in accounts" :acc="account" :key="key"/>
			<div class="link-account box" v-if="state === AccountState.Link">
				<span>Import account</span>
				<p>To import a Legacy game account, please use the <b>Legacy game accounts</b>
				section above.</p>
				<br>
				<button type="button" class="button ghost" @click="state = AccountState.Overview">return</button>
			</div>
			<div class="link-account box" v-else-if="state == AccountState.Create">
				<span>Create new account</span>
				<p>Please choose a username for your new account:</p>
				<br>
				<form class="login" @submit.prevent="state = AccountState.Create2">
					<label for="username">username: </label>
					<input v-focus class="input" required name="username" id="username" ref="username" v-model="user.name" type="text" placeholder="new username" minlength="4" maxlength="23" pattern="^[a-zA-Z0-9_]{4,23}$" title="4-23 characters, alphanumeric and underscores" />
					<br><br>
					<button type="submit" class="button prime">Confirm</button> &nbsp;
					<button type="button" @click="state = AccountState.Overview" class="button ghost">Cancel</button>
				</form>
			</div>
			<div class="link-account box" v-else-if="state === AccountState.Exists">
				<span>Create new account</span>
				<p>This username is already in use. Please use a different username.</p>
				<br>
				<button type="button" class="button ghost" @click="state = AccountState.Create">try again</button>
			</div>
			<div class="link-account box" v-else-if="state === AccountState.Already">
				<span>Create new account</span>
				<p>You already own an account with this name.</p>
				<br>
				<button type="button" class="button ghost" @click="state = AccountState.Overview">return</button>
			</div>
			<div class="link-account box" v-else-if="state == AccountState.Create2">
				<span>Create new account</span>
				<p>Please choose a password for your new account:</p>
				<br>
				<form class="login" @submit.prevent="create">
					<label for="password">password: </label>
					<input class="input" required name="password" id="password" ref="password" v-model="user.password" type="password" placeholder="new password" minlength="8" maxlength="30" pattern="^[^\s][^\t\r\n]{6,28}[^\s]$" title="8-30 characters" />
					<br><br>
					<button type="submit" ref="submit" class="button prime">Confirm</button> &nbsp;
					<button type="button" @click="state = AccountState.Overview" class="button">Cancel</button>
				</form>
				<!-- TODO: check PwnedPasswords -->
			</div>
			<div class="link-account box" v-else-if="state === AccountState.Created">
				<span>Success</span>
				<p>Your account has been created.</p>
				<br>
				<button type="button" class="button ghost" @click="state = AccountState.Overview">return</button>
			</div>
			<div class="link-account overview box" v-else>
				<span>Add account</span>
				<button type="button" @click="state = AccountState.Link" class="button">import from Legacy</button>
				<br>
				<button type="button" @click="state = AccountState.Create" class="button">create new</button>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator"
import GameAccountCard from "@/components/GameAccountCard.vue"

enum AccountState {
	Overview, // initial state
	Link,     // link from Legacy
	Create,   // create new account
	Created,  // successfully created
	Error,    // misc error
	Exists,   // already assigned to another user
	Already,  // user already owns this
	TooMany,  // too many linked accounts
}

@Component({
	data () {
		return { AccountState }
	},
	components: {
		GameAccountCard,
	},
	computed: {
		accounts () {
			return this.$store.state.gameAccounts
		},
	},
})
export default class GameAccounts extends Vue {
	@Prop() private title!: string
	state = AccountState.Overview
	error = ""
	user = {
		name: "",
		password: "",
	}

	async created () {
		// TODO: send an etag so that the api can say if the data is unchanged and avoid re-sending it
		const req = new Request(`${process.env.VUE_APP_API}/vault/evol/account`, {
			method: "GET",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			console.error(err)
			// TODO: actually handle this
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		switch (rawResponse.status) {
		default:
			// TODO: handle errors
			break
		case 200:
			this.$store.commit("setGameAccounts", json.accounts)
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		}
	}

	async create () {
		for (const acc of this.$store.state.gameAccounts) {
			if (acc.name === this.user.name) {
				this.state = AccountState.Already
				return
			}
		}

		const button = this.$refs.submit as HTMLButtonElement
		button.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/evol/account`, {
			method: "POST",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				username: this.user.name,
				password: this.user.password,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = AccountState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()
		button.disabled = false

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		if (Reflect.has(json, "accounts")) {
			this.$store.commit("setGameAccounts", json.accounts)
		} else if (Reflect.has(json, "account")) {
			this.$store.commit("pushGameAccount", json.account)
		}

		switch (rawResponse.status) {
		case 200:
			this.state = AccountState.Created
			return
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 409:
			this.state = AccountState.Exists
			break
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 416:
			this.state = AccountState.TooMany
			break
		case 429:
			this.state = AccountState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = AccountState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = AccountState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = AccountState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>

<style scoped>
	.accountContainer {
		display: grid;
		margin-top: 1em;
		grid-auto-rows: auto;
		grid-gap: 1rem;
		grid-template-columns: repeat(auto-fill, 250px);
	}

	.link-account {
		background: var(--main-1);
		box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2);
		margin: 0;
		padding: .8rem;
		display: flex;
		flex-direction: column;
		flex-wrap: wrap;

		& span {
			font-size: 1.2em;
			margin-bottom: .5rem;
		}

		& button {
			width: 100%;
		}

		&.overview {
			& button {
				padding: 1rem;
				margin: auto;
			}
		}
	}
</style>
